; hUser v1.0
; by Lord_Daur <lorddaur@webzone.net>
;
; This is a auto-op, voice and dead list for mIRC 5.8+
; using HASH tables.  It is channel specific and is
; very fast and efficient.  This is my first public
; script that I have written, so the coding may be
; a bit sloppy, but it does work, and it works well.
;
; Known Bugs: You can only have someone in your userlists for 1 (one)
;             channel only, if you try to add them to another channel
;             it will remove them from the list for the other channel.
;
; Future Versions:
; 
; Will include multiple channel support, password authorization for Undernet
; style servers.
;
; Lord_Daur

menu nicklist {
  [] User Lists
  .[] Op List
  ..[] Add $address($$1,19): {
    .hadd op $$1 $address($$1,19)
    .hadd channel $$1 $chan
    echo -a [] OP LIST [] $$1 was added to your OP List
    halt
  }
  ..[] Delete $address($$1,19): {
    .hdel op $$1
    .hdel channel $$1
    echo -a [] OP LIST[] $$1 was removed from your OP List
    halt
  }
  .[] Voice List
  ..[] Add $address($$1,19): {
    .hadd voice $$1 $address($$1,19)
    .hadd channel $$1 $chan
    echo -a [] VOICE LIST [] $$1 was added to your VOICE List
    halt
  }
  ..[] Delete $address($$1,19):{
    .hdel voice $$1
    .hdel channel $$1
    echo -a [] VOICE LIST [] $$1 was removed from your VOICE List
    halt
  }
  .[] Dead List
  ..[] Add $address($$1,19): {
    .hadd dead $$1 $address($$1,19)
    .hadd channel $$1 $chan
    echo -a [] DEAD LIST [] $$1 was added to your DEAD List
    halt
  }
  ..[] Delete $address($$1,19):{
    .hdel dead $$1
    .hdel channel $$1
    echo -a [] DEAD LIST [] $$1 was removed from your DEAD List
    halt
  }
}

on 1:CONNECT:{
  .hmake op 100
  .hmake voice 100
  .hmake dead 100
  .hmake channel 100
  .hload op op
  .hload voice voice
  .hload dead dead
  .hload channel channel
}

on 1:DISCONNECT: {
  .hsave -b op op
  .hsave -b voice voice
  .hsave -b dead dead
  .hsave -b channel channel
}

on 1:JOIN:#: {
  set %user.nick $nick
  set %user.channel #
  set %user.address $address($nick,19)
  if ((%user.address == $hget(op,$nick)) && (%user.address != $hget(voice,$nick)) && (%user.address != $hget(dead,$nick)) && (%user.channel == $hget(channel,%user.nick))) {
    mode # +o $nick
    halt
  }
  if ((%user.address != $hget(op,$nick)) && (%user.address == $hget(voice,$nick)) && (%user.channel == $hget(channel,%user.nick))) {
    mode # +v $nick
    halt
  }
  if ((%user.address != $hget(op,$nick)) && (%user.address != $hget(voice,$nick)) && (%user.address == $hget(dead,$nick)) && (%user.channel == $hget(channel,%user.nick))) {
    mode # +b $address($nick,9)
    kick # $nick [] BANNED []
    halt
  }
  unset %user.*
}
